Index: uspace/drv/nic/rtl8139/defs.h
===================================================================
--- uspace/drv/nic/rtl8139/defs.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/rtl8139/defs.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -29,33 +29,29 @@
 /** @file rtl8139_defs.h
  *
- * Registers, bit positions and masks definition
- * of the RTL8139 network family cards
- */
-
-#ifndef RTL8139_DEFS_H_
-#define RTL8139_DEFS_H_
-
+ *  Registers, bit positions and masks definition of the RTL8139 network family 
+ *  cards
+ */
+
+#ifndef RTL8139_DEFS_H_INCLUDED_
+#define RTL8139_DEFS_H_INCLUDED_
 #include <sys/types.h>
 #include <libarch/ddi.h>
 
-/** Size of RTL8139 registers address space */
-#define RTL8139_IO_SIZE  256
-
-/** Maximal transmitted frame length
- *
- * Maximal transmitted frame length in bytes
- * allowed according to the RTL8139 documentation
- * (see SIZE part of TSD documentation).
- *
- */
-#define RTL8139_FRAME_MAX_LENGTH  1792
+
+/** The size of RTL8139 registers address space */
+#define RTL8139_IO_SIZE 256
+
+/** The maximal transmitted packet length in bytes allowed according to RTL8139
+ *  documentation (see SIZE part of TSD documentation)
+ */
+#define RTL8139_PACKET_MAX_LENGTH 1792
+
 
 /** HW version
  *
- * As can be detected from HWVERID part of TCR
- * (Transmit Configuration Register).
- *
- */
-typedef enum {
+ *  as can be detected from HWVERID part of TCR
+ *  (Transmit Configuration Register)
+ */
+enum rtl8139_version_id {
 	RTL8139 = 0,          /**< RTL8139 */
 	RTL8139A,             /**< RTL8139A */
@@ -70,5 +66,7 @@
 	RTL8101,              /**< RTL8101 */
 	RTL8139_VER_COUNT     /**< Count of known RTL versions, the last value */
-} rtl8139_version_id_t;
+};
+
+extern const char* model_names[RTL8139_VER_COUNT];
 
 /** Registers of RTL8139 family card offsets from the memory address base */
@@ -77,5 +75,5 @@
 	MAC0  = IDR0,    /**< Alias for IDR0 */
 
-	// 0x06 - 0x07 reserved
+	// 0x6 - 0x7 reserved
 
 	MAR0    = 0x08,  /**< Multicast mask registers 8 1b registers sequence */
@@ -96,5 +94,5 @@
 
 	CR      = 0x37,  /**< Command register, 1b */
-	CAPR    = 0x38,  /**< Current address of frame read, 2b */
+	CAPR    = 0x38,  /**< Current address of packet read, 2b */
 	CBA     = 0x3a,  /**< Current buffer address, 2b */
 
@@ -215,5 +213,4 @@
 	pio_write_8(io_base + CR9346, RTL8139_REGS_LOCKED);
 }
-
 /** Allow to change Config0-4 and BMCR register  */
 static inline void rtl8139_regs_unlock(void *io_base)
@@ -285,5 +282,5 @@
 	RCR_MulERINT = 1 << 17,    /**< Multiple early interrupt select */
 
-	/** Minimal error frame length (1 = 8B, 0 = 64B). If AER/AR is set, RER8
+	/** Minimal error packet length (1 = 8B, 0 = 64B). If AER/AR is set, RER8
 	 * is "Don't care"
 	 */
@@ -305,10 +302,10 @@
 
 	RCR_WRAP              = 1 << 7,  /**< Rx buffer wrapped */
-	RCR_ACCEPT_ERROR      = 1 << 5,  /**< Accept error frame */
-	RCR_ACCEPT_RUNT       = 1 << 4,  /**< Accept Runt (8-64 bytes) frames */
+	RCR_ACCEPT_ERROR      = 1 << 5,  /**< Accept error packet */
+	RCR_ACCEPT_RUNT       = 1 << 4,  /**< Accept Runt (8-64 bytes) packets */
 	RCR_ACCEPT_BROADCAST  = 1 << 3,  /**< Accept broadcast */
 	RCR_ACCEPT_MULTICAST  = 1 << 2,  /**< Accept multicast */
 	RCR_ACCEPT_PHYS_MATCH = 1 << 1,  /**< Accept device MAC address match */
-	RCR_ACCEPT_ALL_PHYS   = 1 << 0,  /**< Accept all frames with 
+	RCR_ACCEPT_ALL_PHYS   = 1 << 0,  /**< Accept all packets with 
 	                                  * phys. desticnation 
 									  */
@@ -365,5 +362,5 @@
 	ANAR_ACK          = (1 << 14),  /**< Capability reception acknowledge */
 	ANAR_REMOTE_FAULT = (1 << 13),  /**< Remote fault detection capability */
-	ANAR_PAUSE        = (1 << 10),  /**< Symetric pause frame capability */
+	ANAR_PAUSE        = (1 << 10),  /**< Symetric pause packet capability */
 	ANAR_100T4        = (1 << 9),   /**< T4, not supported by the device */
 	ANAR_100TX_FD     = (1 << 8),   /**< 100BASE_TX full duplex */
@@ -402,5 +399,5 @@
 	CONFIG3_GNT_SELECT = (1 << 7),  /**< Gnt select */
 	CONFIG3_PARM_EN    = (1 << 6),  /**< Parameter enabled (100MBit mode) */
-	CONFIG3_MAGIC      = (1 << 5),  /**< WoL Magic frame enable */
+	CONFIG3_MAGIC      = (1 << 5),  /**< WoL Magic packet enable */
 	CONFIG3_LINK_UP    = (1 << 4),  /**< Wakeup if link is reestablished */
 	CONFIG3_CLKRUN_EN  = (1 << 2),  /**< CLKRUN enabled */ /* TODO: check what does it mean */
@@ -419,9 +416,9 @@
 };
 
-/** Maximal runt frame size + 1 */
-#define RTL8139_RUNT_MAX_SIZE  64
-
-/** Bits in frame header */
-enum rtl8139_frame_header {
+/** Maximal runt packet size + 1 */
+#define RTL8139_RUNT_MAX_SIZE 64
+
+/** Bits in packet header */
+enum rtl8139_packet_header {
 	RSR_MAR  = (1 << 15),  /**< Multicast received */
 	RSR_PAM  = (1 << 14),  /**< Physical address match */
@@ -429,10 +426,10 @@
 
 	RSR_ISE  = (1 << 5),   /**< Invalid symbol error, 100BASE-TX only */
-	RSR_RUNT = (1 << 4),   /**< Runt frame (< RTL8139_RUNT_MAX_SIZE bytes) */
-
-	RSR_LONG = (1 << 3),   /**< Long frame (size > 4k bytes) */
+	RSR_RUNT = (1 << 4),   /**< Runt packet (< RTL8139_RUNT_MAX_SIZE bytes) */
+
+	RSR_LONG = (1 << 3),   /**< Long packet (size > 4k bytes) */
 	RSR_CRC  = (1 << 2),   /**< CRC error */
 	RSR_FAE  = (1 << 1),   /**< Frame alignment error */
-	RSR_ROK  = (1 << 0)    /**< Good frame received */
+	RSR_ROK  = (1 << 0)    /**< Good packet received */
 };
 
@@ -454,5 +451,5 @@
 									  */
 
-	APPEND_CRC = 1 << 16,        /**< Append CRC at the end of a frame */
+	APPEND_CRC = 1 << 16,        /**< Append CRC at the end of a packet */
 
 	MXTxDMA_SHIFT = 8,  /**< Max. DMA Burst per TxDMA shift, burst = 16^value */
@@ -462,5 +459,5 @@
 	TX_RETRY_COUNT_SIZE  = 4,            /**< Retries before aborting size */
 
-	CLEAR_ABORT = 1 << 0    /**< Retransmit aborted frame at the last 
+	CLEAR_ABORT = 1 << 0    /**< Retransmit aborted packet at the last 
 	                          *  transmitted descriptor 
 							  */
@@ -473,21 +470,19 @@
 
 /** Mapping of HW version -> version ID */
-struct rtl8139_hwver_map {
-	uint32_t hwverid;             /**< HW version value in the register */
-	rtl8139_version_id_t ver_id;  /**< appropriate version id */
+struct rtl8139_hwver_map { 
+	uint32_t hwverid;                /**< HW version value in the register */
+	enum rtl8139_version_id ver_id;  /**< appropriate version id */
 };
 
 /** Mapping of HW version -> version ID */
 extern const struct rtl8139_hwver_map rtl8139_versions[RTL8139_VER_COUNT + 1];
-extern const char* model_names[RTL8139_VER_COUNT];
-
-/** Size in the frame header while copying from RxFIFO to Rx buffer */
-#define RTL8139_EARLY_SIZE  UINT16_C(0xfff0)
-
-/** The only supported pause frame time value */
-#define RTL8139_PAUSE_VAL  UINT16_C(0xFFFF)
-
-/** Size of the frame header in front of the received frame */
-#define RTL_FRAME_HEADER_SIZE  4
+
+/** Size in the packet header while copying from RxFIFO to Rx buffer */
+#define RTL8139_EARLY_SIZE UINT16_C(0xfff0)
+/** The only supported pause packet time value */
+#define RTL8139_PAUSE_VAL UINT16_C(0xFFFF)
+
+/** Size of the packet header in front of the received frame */
+#define RTL_PACKET_HEADER_SIZE 4
 
 /** 8k buffer */
Index: uspace/drv/nic/rtl8139/driver.c
===================================================================
--- uspace/drv/nic/rtl8139/driver.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/rtl8139/driver.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -39,4 +39,5 @@
 #include <io/log.h>
 #include <nic.h>
+#include <packet_client.h>
 #include <device/pci.h>
 
@@ -55,28 +56,21 @@
 /** Global mutex for work with shared irq structure */
 FIBRIL_MUTEX_INITIALIZE(irq_reg_lock);
-
 /** Lock interrupt structure mutex */
-#define RTL8139_IRQ_STRUCT_LOCK() \
-	fibril_mutex_lock(&irq_reg_lock)
-
+#define RTL8139_IRQ_STRUCT_LOCK() fibril_mutex_lock(&irq_reg_lock)
 /** Unlock interrupt structure mutex */
-#define RTL8139_IRQ_STRUCT_UNLOCK() \
-	fibril_mutex_unlock(&irq_reg_lock)
+#define RTL8139_IRQ_STRUCT_UNLOCK() fibril_mutex_unlock(&irq_reg_lock)
 
 /** PCI clock frequency in kHz */
-#define RTL8139_PCI_FREQ_KHZ  33000
-
-#define RTL8139_AUTONEG_CAPS (ETH_AUTONEG_10BASE_T_HALF | \
-	ETH_AUTONEG_10BASE_T_FULL | ETH_AUTONEG_100BASE_TX_HALF | \
-	ETH_AUTONEG_100BASE_TX_FULL | ETH_AUTONEG_PAUSE_SYMETRIC)
+#define RTL8139_PCI_FREQ_KHZ 33000
+
+#define RTL8139_AUTONEG_CAPS (ETH_AUTONEG_10BASE_T_HALF \
+    | ETH_AUTONEG_10BASE_T_FULL | ETH_AUTONEG_100BASE_TX_HALF \
+    | ETH_AUTONEG_100BASE_TX_FULL | ETH_AUTONEG_PAUSE_SYMETRIC)
 
 /** Lock transmitter and receiver data
- *
- * This function shall be called whenever
- * both transmitter and receiver locking
- * to force safe lock ordering (deadlock prevention)
- *
- * @param rtl8139 RTL8139 private data
- *
+ *  This function shall be called whenever both transmitter and receiver locking
+ *  to force safe lock ordering (deadlock prevention)
+ *
+ *  @param rtl8139  RTL8139 private data
  */
 inline static void rtl8139_lock_all(rtl8139_t *rtl8139)
@@ -89,6 +83,5 @@
 /** Unlock transmitter and receiver data
  *
- * @param rtl8139 RTL8139 private data
- *
+ *  @param rtl8139  RTL8139 private data
  */
 inline static void rtl8139_unlock_all(rtl8139_t *rtl8139)
@@ -159,5 +152,5 @@
 }
 
-/** Update the mask of accepted frames in the RCR register according to
+/** Update the mask of accepted packets in the RCR register according to
  * rcr_accept_mode value in rtl8139_t
  *
@@ -177,5 +170,5 @@
 }
 
-/** Fill the mask of accepted multicast frames in the card registers
+/** Fill the mask of accepted multicast packets in the card registers
  *
  *  @param rtl8139  The rtl8139 private data
@@ -401,5 +394,5 @@
 #define rtl8139_tbuf_busy(tsd) ((pio_read_32(tsd) & TSD_OWN) == 0)
 
-/** Send frame with the hardware
+/** Send packet with the hardware
  *
  * note: the main_lock is locked when framework calls this function
@@ -419,5 +412,5 @@
 	ddf_msg(LVL_DEBUG, "Sending frame");
 
-	if (size > RTL8139_FRAME_MAX_LENGTH) {
+	if (size > RTL8139_PACKET_MAX_LENGTH) {
 		ddf_msg(LVL_ERROR, "Send frame: frame too long, %zu bytes",
 		    size);
@@ -444,5 +437,5 @@
 	fibril_mutex_unlock(&rtl8139->tx_lock);
 
-	/* Get address of the buffer descriptor and frame data */
+	/* Get address of the buffer descriptor and packet data */
 	void *tsd = rtl8139->io_port + TSD0 + tx_curr * 4;
 	void *buf_addr = rtl8139->tx_buff[tx_curr];
@@ -465,5 +458,5 @@
 	pio_write_32(tsd, tsd_value);
 	return;
-	
+
 err_busy_no_inc:
 err_size:
@@ -512,26 +505,32 @@
 }
 
-/** Create frame structure from the buffer data
+/** Create packet structure from the buffer data
  *
  * @param nic_data      NIC driver data
  * @param rx_buffer     The receiver buffer
  * @param rx_size       The buffer size
- * @param frame_start   The offset where packet data start
- * @param frame_size    The size of the frame data
- *
- * @return The frame list node (not connected)
- *
- */
-static nic_frame_t *rtl8139_read_frame(nic_t *nic_data,
-    void *rx_buffer, size_t rx_size, size_t frame_start, size_t frame_size)
-{
-	nic_frame_t *frame = nic_alloc_frame(nic_data, frame_size);
+ * @param packet_start  The offset where packet data start
+ * @param packet_size   The size of the packet data
+ *
+ * @return The packet   list node (not connected)
+ */
+static nic_frame_t *rtl8139_read_packet(nic_t *nic_data,
+    void *rx_buffer, size_t rx_size, size_t packet_start, size_t packet_size)
+{
+	nic_frame_t *frame = nic_alloc_frame(nic_data, packet_size);
 	if (! frame) {
-		ddf_msg(LVL_ERROR, "Can not allocate frame for received frame.");
+		ddf_msg(LVL_ERROR, "Can not allocate frame for received packet.");
 		return NULL;
 	}
 
-	void *ret = rtl8139_memcpy_wrapped(frame->data, rx_buffer, frame_start,
-	    RxBUF_SIZE, frame_size);
+	void *packet_data = packet_suffix(frame->packet, packet_size);
+	if (!packet_data) {
+		ddf_msg(LVL_ERROR, "Can not get the packet suffix.");
+		nic_release_frame(nic_data, frame);
+		return NULL;
+	}
+
+	void *ret = rtl8139_memcpy_wrapped(packet_data, rx_buffer, packet_start,
+	    RxBUF_SIZE, packet_size);
 	if (ret == NULL) {
 		nic_release_frame(nic_data, frame);
@@ -569,10 +568,10 @@
 }
 
-/** Receive all frames in queue
+/** Receive all packets in queue
  *
  *  @param nic_data  The controller data
- *  @return The linked list of nic_frame_list_t nodes, each containing one frame
- */
-static nic_frame_list_t *rtl8139_frame_receive(nic_t *nic_data)
+ *  @return The linked list of packet_list_t nodes, each containing one packet
+ */
+static nic_frame_list_t *rtl8139_packet_receive(nic_t *nic_data)
 {
 	rtl8139_t *rtl8139 = nic_get_specific(nic_data);
@@ -582,5 +581,5 @@
 	nic_frame_list_t *frames = nic_alloc_frame_list();
 	if (!frames)
-		ddf_msg(LVL_ERROR, "Can not allocate frame list for received frames.");
+		ddf_msg(LVL_ERROR, "Can not allocate frame list for received packets.");
 
 	void *rx_buffer = rtl8139->rx_buff_virt;
@@ -606,12 +605,12 @@
 	while (!rtl8139_hw_buffer_empty(rtl8139)) {
 		void *rx_ptr = rx_buffer + rx_offset % RxBUF_SIZE;
-		uint32_t frame_header = uint32_t_le2host( *((uint32_t*)rx_ptr) );
-		uint16_t size = frame_header >> 16;
-		uint16_t frame_size = size - RTL8139_CRC_SIZE;
-		/* received frame flags in frame header */
-		uint16_t rcs = (uint16_t) frame_header;
+		uint32_t packet_header = uint32_t_le2host( *((uint32_t*)rx_ptr) );
+		uint16_t size = packet_header >> 16;
+		uint16_t packet_size = size - RTL8139_CRC_SIZE;
+		/* received packet flags in packet header */
+		uint16_t rcs = (uint16_t) packet_header;
 
 		if (size == RTL8139_EARLY_SIZE) {
-			/* The frame copying is still in progress, break receiving */
+			/* The packet copying is still in progress, break receiving */
 			ddf_msg(LVL_DEBUG, "Early threshold reached, not completely coppied");
 			break;
@@ -619,7 +618,7 @@
 
 		/* Check if the header is valid, otherwise we are lost in the buffer */
-		if (size == 0 || size > RTL8139_FRAME_MAX_LENGTH) {
+		if (size == 0 || size > RTL8139_PACKET_MAX_LENGTH) {
 			ddf_msg(LVL_ERROR, "Receiver error -> receiver reset (size: %4"PRIu16", "
-			    "header 0x%4"PRIx16". Offset: %zu)", size, frame_header, 
+			    "header 0x%4"PRIx16". Offset: %zu)", size, packet_header, 
 			    rx_offset);
 			goto rx_err;
@@ -630,11 +629,11 @@
 		}
 
-		cur_read += size + RTL_FRAME_HEADER_SIZE;
+		cur_read += size + RTL_PACKET_HEADER_SIZE;
 		if (cur_read > max_read)
 			break;
 
 		if (frames) {
-			nic_frame_t *frame = rtl8139_read_frame(nic_data, rx_buffer,
-			    RxBUF_SIZE, rx_offset + RTL_FRAME_HEADER_SIZE, frame_size);
+			nic_frame_t *frame = rtl8139_read_packet(nic_data, rx_buffer,
+			    RxBUF_SIZE, rx_offset + RTL_PACKET_HEADER_SIZE, packet_size);
 
 			if (frame)
@@ -643,7 +642,7 @@
 
 		/* Update offset */
-		rx_offset = ALIGN_UP(rx_offset + size + RTL_FRAME_HEADER_SIZE, 4);
-
-		/* Write lesser value to prevent overflow into unread frame
+		rx_offset = ALIGN_UP(rx_offset + size + RTL_PACKET_HEADER_SIZE, 4);
+
+		/* Write lesser value to prevent overflow into unread packet
 		 * (the recomendation from the RealTech rtl8139 programming guide)
 		 */
@@ -728,5 +727,5 @@
 		tx_used++;
 
-		/* If the frame was sent */
+		/* If the packet was sent */
 		if (tsd_value & TSD_TOK) {
 			size_t size = REG_GET_VAL(tsd_value, TSD_SIZE);
@@ -758,9 +757,9 @@
 }
 
-/** Receive all frames from the buffer
+/** Receive all packets from the buffer
  *
  *  @param rtl8139  driver private data
  */
-static void rtl8139_receive_frames(nic_t *nic_data)
+static void rtl8139_receive_packets(nic_t *nic_data)
 {
 	assert(nic_data);
@@ -770,5 +769,5 @@
 
 	fibril_mutex_lock(&rtl8139->rx_lock);
-	nic_frame_list_t *frames = rtl8139_frame_receive(nic_data);
+	nic_frame_list_t *frames = rtl8139_packet_receive(nic_data);
 	fibril_mutex_unlock(&rtl8139->rx_lock);
 
@@ -826,5 +825,5 @@
 	}
 
-	/* Check transmittion interrupts first to allow transmit next frames
+	/* Check transmittion interrupts first to allow transmit next packets
 	 * sooner
 	 */
@@ -833,5 +832,5 @@
 	}
 	if (isr & INT_ROK) {
-		rtl8139_receive_frames(nic_data);
+		rtl8139_receive_packets(nic_data);
 	}
 	if (isr & (INT_RER | INT_RXOVW | INT_FIFOOVW)) {
@@ -934,5 +933,5 @@
 }
 
-/** Activate the device to receive and transmit frames
+/** Activate the device to receive and transmit packets
  *
  *  @param nic_data  The nic driver data
@@ -1214,15 +1213,15 @@
 		goto failed;
 
-	/* Set default frame acceptance */
+	/* Set default packet acceptance */
 	rtl8139->rcr_data.ucast_mask = RTL8139_RCR_UCAST_DEFAULT;
 	rtl8139->rcr_data.mcast_mask = RTL8139_RCR_MCAST_DEFAULT;
 	rtl8139->rcr_data.bcast_mask = RTL8139_RCR_BCAST_DEFAULT;
 	rtl8139->rcr_data.defect_mask = RTL8139_RCR_DEFECT_DEFAULT;
-	/* Set receiver early treshold to 8/16 of frame length */
+	/* Set receiver early treshold to 8/16 of packet length */
 	rtl8139->rcr_data.rcr_base = (0x8 << RCR_ERTH_SHIFT);
 
 	ddf_msg(LVL_DEBUG, "The device is initialized");
 	return ret;
-	
+
 failed:
 	ddf_msg(LVL_ERROR, "The device initialization failed");
@@ -1289,6 +1288,4 @@
 int rtl8139_dev_add(ddf_dev_t *dev)
 {
-	ddf_fun_t *fun;
-
 	assert(dev);
 	ddf_msg(LVL_NOTE, "RTL8139_dev_add %s (handle = %d)", dev->name, dev->handle);
@@ -1327,22 +1324,8 @@
 	}
 
-	fun = ddf_fun_create(nic_get_ddf_dev(nic_data), fun_exposed, "port0");
-	if (fun == NULL) {
-		ddf_msg(LVL_ERROR, "Failed creating device function");
-		goto err_srv;
-	}
-	nic_set_ddf_fun(nic_data, fun);
-	fun->ops = &rtl8139_dev_ops;
-	fun->driver_data = nic_data;
-
-	rc = ddf_fun_bind(fun);
+	rc = nic_register_as_ddf_fun(nic_data, &rtl8139_dev_ops);
 	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed binding device function");
-		goto err_fun_create;
-	}
-	rc = ddf_fun_add_to_category(fun, DEVICE_CATEGORY_NIC);
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding function to category");
-		goto err_fun_bind;
+		ddf_msg(LVL_ERROR, "Failed to register as DDF function - error %d", rc);
+		goto err_irq;
 	}
 
@@ -1351,11 +1334,5 @@
 
 	return EOK;
-	
-err_fun_bind:
-	ddf_fun_unbind(fun);
-err_fun_create:
-	ddf_fun_destroy(fun);
-err_srv:
-	/* XXX Disconnect from services */
+
 err_irq:
 	unregister_interrupt_handler(dev, rtl8139->irq);
@@ -1500,5 +1477,5 @@
 };
 
-/** Check if pause frame operations are valid in current situation 
+/** Check if pause packet operations are valid in current situation 
  *
  *  @param rtl8139  RTL8139 private structure
@@ -1525,5 +1502,5 @@
 }
 
-/** Get current pause frame configuration
+/** Get current pause packet configuration
  *
  *  Values are filled with NIC_RESULT_NOT_AVAILABLE if the value has no sense in
@@ -1531,7 +1508,7 @@
  *
  *  @param[in]  fun         The DDF structure of the RTL8139
- *  @param[out] we_send     Sign if local constroller sends pause frame
- *  @param[out] we_receive  Sign if local constroller receives pause frame
- *  @param[out] time        Time filled in pause frames. 0xFFFF in rtl8139
+ *  @param[out] we_send     Sign if local constroller sends pause packets
+ *  @param[out] we_receive  Sign if local constroller receives pause packets
+ *  @param[out] time        Time filled in pause packets. 0xFFFF in rtl8139
  *
  *  @return EOK if succeed
@@ -1563,12 +1540,12 @@
 };
 
-/** Set current pause frame configuration
+/** Set current pause packet configuration
  *
  *  @param fun            The DDF structure of the RTL8139
- *  @param allow_send     Sign if local constroller sends pause frame
- *  @param allow_receive  Sign if local constroller receives pause frames
+ *  @param allow_send     Sign if local constroller sends pause packets
+ *  @param allow_receive  Sign if local constroller receives pause packets
  *  @param time           Time to use, ignored (not supported by device)
  *
- *  @return EOK if succeed, INVAL if the pause frame has no sence
+ *  @return EOK if succeed, INVAL if the pause packet has no sence
  */
 static int rtl8139_pause_set(ddf_fun_t *fun, int allow_send, int allow_receive, 
@@ -1819,5 +1796,5 @@
 }
 
-/** Set unicast frames acceptance mode
+/** Set unicast packets acceptance mode
  *
  *  @param nic_data  The nic device to update
@@ -1877,5 +1854,5 @@
 }
 
-/** Set multicast frames acceptance mode
+/** Set multicast packets acceptance mode
  *
  *  @param nic_data  The nic device to update
@@ -1922,5 +1899,5 @@
 }
 
-/** Set broadcast frames acceptance mode
+/** Set broadcast packets acceptance mode
  *
  *  @param nic_data  The nic device to update
@@ -1952,5 +1929,5 @@
 }
 
-/** Get state of acceptance of weird frames
+/** Get state of acceptance of weird packets
  *
  *  @param[in]  device  The device to check
@@ -1974,5 +1951,5 @@
 };
 
-/** Set acceptance of weird frames
+/** Set acceptance of weird packets
  *
  *  @param device  The device to update
@@ -2150,5 +2127,5 @@
 }
 
-/** Force receiving all frames in the receive buffer
+/** Force receiving all packets in the receive buffer
  *
  *  @param device  The device to receive
Index: uspace/drv/nic/rtl8139/driver.h
===================================================================
--- uspace/drv/nic/rtl8139/driver.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/rtl8139/driver.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -30,40 +30,36 @@
 #define RTL8139_DRIVER_H_
 
+#include "defs.h"
+#include "general.h"
 #include <sys/types.h>
 #include <stdint.h>
-#include "defs.h"
-#include "general.h"
 
 /** The driver name */
-#define NAME  "rtl8139"
-
+#define NAME "rtl8139"
 /** Transmittion buffers count */
-#define TX_BUFF_COUNT  4
-
-/** Size of buffer for one frame (2kB) */
-#define TX_BUFF_SIZE  (2 * 1024)
-
-/** Number of pages to allocate for TxBuffers */
-#define TX_PAGES  2
+#define TX_BUFF_COUNT 4
+/** Size of buffer for one packet
+ *  - 2kB
+ */
+#define TX_BUFF_SIZE (2 * 1024)
+/** Count of pages to allocate for TxBuffers */
+#define TX_PAGES 2
 
 /** Size of the CRC after the received frame in the receiver buffer */
-#define RTL8139_CRC_SIZE  4
-
-/** The default mode of accepting unicast frames */
-#define RTL8139_RCR_UCAST_DEFAULT  RCR_ACCEPT_PHYS_MATCH
-
-/** The default mode of accepting multicast frames */
-#define RTL8139_RCR_MCAST_DEFAULT  0
-
-/** The default mode of accepting broadcast frames */
-#define RTL8139_RCR_BCAST_DEFAULT  RCR_ACCEPT_BROADCAST
-
-/** The default mode of accepting defect frames */
-#define RTL8139_RCR_DEFECT_DEFAULT  0
+#define RTL8139_CRC_SIZE 4
+
+/** The default mode of accepting unicast packets */
+#define RTL8139_RCR_UCAST_DEFAULT RCR_ACCEPT_PHYS_MATCH
+/** The default mode of accepting multicast packets */
+#define RTL8139_RCR_MCAST_DEFAULT 0
+/** The default mode of accepting broadcast packets */
+#define RTL8139_RCR_BCAST_DEFAULT RCR_ACCEPT_BROADCAST
+/** The default mode of accepting defect packets */
+#define RTL8139_RCR_DEFECT_DEFAULT 0
 
 /** Mask for accepting all multicast */
-#define RTL8139_MCAST_MASK_PROMISC  UINT64_MAX
-
-/** Data */
+#define RTL8139_MCAST_MASK_PROMISC UINT64_MAX
+
+/** Data  */
 struct rtl8139_rcr_data {
 	/** Configuration part of RCR */
@@ -116,5 +112,5 @@
 	size_t tx_used;
 
-	/** Buffer for receiving frames */
+	/** Buffer for receiving packets */
 	void *rx_buff_phys;
 	void *rx_buff_virt;
@@ -138,6 +134,7 @@
 
 	/** Version of RT8139 controller */
-	rtl8139_version_id_t hw_version;
+	enum rtl8139_version_id hw_version;
 } rtl8139_t;
+
 
 /* ***** Pointers casting - for both amd64 and ia32 ***** */
@@ -163,4 +160,6 @@
  */
 #define IOADDR_TO_PTR(ioaddr) ((void*)((size_t)(ioaddr)))
+
+
 
 /* ***** Bit operation macros ***** */
@@ -178,5 +177,5 @@
  * @return New value
  */
-#define bit_set_part_g(src, value, mask, type) \
+#define bit_set_part_g( src, value, mask, type ) \
 	((type)(((src) & ~((type)(mask))) | ((value) & (type)(mask))))
 
@@ -238,3 +237,4 @@
 	bit_set_part_32(tsd_value, (size) << TSD_SIZE_SHIFT, TSD_SIZE_MASK << TSD_SIZE_SHIFT)
 
+
 #endif
Index: uspace/drv/nic/rtl8139/general.h
===================================================================
--- uspace/drv/nic/rtl8139/general.h	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/drv/nic/rtl8139/general.h	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -29,5 +29,5 @@
 /** @file
  *
- * General functions and structures used in rtl8139 driver
+ *  General functions and structures used in rtl8139 driver
  */
 
@@ -37,30 +37,30 @@
 #include <unistd.h>
 
-/** Number of microseconds in second */
-#define RTL8139_USEC_IN_SEC  1000000
+extern void* rtl8139_memcpy_wrapped(void *dest, const void *src_buf,
+    size_t src_offset, size_t src_size, size_t data_size);
+
 
 /** Structure for HW timer control */
-typedef struct {
+typedef struct rtl8139_timer_act {
 	/** Register value set in the last timer period */
 	uint32_t last_val;
-	
 	/** Register value set in the common timer period */
 	uint32_t full_val;
-	
+
 	/** Amount of full register periods in timer period */
 	size_t full_skips;
-	
 	/** Remaining full register periods to the next period end */
 	size_t full_skips_remains;
-	
 	/** Mark if there is a last run */
 	int last_run;
 } rtl8139_timer_act_t;
 
-extern void *rtl8139_memcpy_wrapped(void *, const void *, size_t, size_t,
-    size_t);
-extern int rtl8139_timer_act_init(rtl8139_timer_act_t *, uint32_t,
-    const struct timeval *);
-extern int rtl8139_timer_act_step(rtl8139_timer_act_t *, uint32_t *);
+/** Count of microseconds in second */
+#define RTL8139_USEC_IN_SEC 1000000
+
+extern int rtl8139_timer_act_init(rtl8139_timer_act_t *ta, uint32_t timer_freq,
+    const struct timeval *time);
+extern int rtl8139_timer_act_step(rtl8139_timer_act_t *ta, uint32_t *new_reg);
+
 
 #endif
Index: uspace/lib/c/generic/device/nic.c
===================================================================
--- uspace/lib/c/generic/device/nic.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/c/generic/device/nic.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -73,7 +73,8 @@
 }
 
-/** Create callback connection from NIC service
- *
- * @param[in] dev_sess
+/** Connect the driver to the NET and NIL services
+ *
+ * @param[in] dev_sess
+ * @param[in] nil_service Service identifier for the NIL service
  * @param[in] device_id
  *
@@ -81,24 +82,13 @@
  *
  */
-int nic_callback_create(async_sess_t *dev_sess, async_client_conn_t cfun,
-    void *carg)
-{
-	ipc_call_t answer;
-	int rc;
-	sysarg_t retval;
-	
-	async_exch_t *exch = async_exchange_begin(dev_sess);
-	aid_t req = async_send_1(exch, DEV_IFACE_ID(NIC_DEV_IFACE),
-	    NIC_CALLBACK_CREATE, &answer);
-	
-	rc = async_connect_to_me(exch, 0, 0, 0, cfun, carg);
-	if (rc != EOK) {
-		async_wait_for(req, NULL);
-		return rc;
-	}
-	async_exchange_end(exch);
-	
-	async_wait_for(req, &retval);
-	return (int) retval;
+int nic_connect_to_nil(async_sess_t *dev_sess, services_t nil_service,
+    nic_device_id_t device_id)
+{
+	async_exch_t *exch = async_exchange_begin(dev_sess);
+	int rc = async_req_3_0(exch, DEV_IFACE_ID(NIC_DEV_IFACE),
+	    NIC_CONNECT_TO_NIL, nil_service, device_id);
+	async_exchange_end(exch);
+	
+	return rc;
 }
 
@@ -345,5 +335,5 @@
  * it can never force the NIC to advertise unsupported modes.
  *
- * The allowed modes are defined in "nic/eth_phys.h" in the C library.
+ * The allowed modes are defined in "net/eth_phys.h" in the C library.
  *
  * @param[in] dev_sess
@@ -382,5 +372,5 @@
 /** Probe current state of auto-negotiation.
  *
- * Modes are defined in the "nic/eth_phys.h" in the C library.
+ * Modes are defined in the "net/eth_phys.h" in the C library.
  *
  * @param[in]  dev_sess
Index: uspace/lib/c/generic/loc.c
===================================================================
--- uspace/lib/c/generic/loc.c	(revision e10d41aadcc79d6daf95be94a88c873b2da4e492)
+++ uspace/lib/c/generic/loc.c	(revision 96d9cdd7d2e57187ac2e549b249f642b6dc1522f)
@@ -47,5 +47,4 @@
 static FIBRIL_MUTEX_INITIALIZE(loc_callback_mutex);
 static bool loc_callback_created = false;
-static loc_cat_change_cb_t cat_change_cb = NULL;
 
 static async_sess_t *loc_supp_block_sess = NULL;
@@ -55,6 +54,10 @@
 static async_sess_t *loc_consumer_sess = NULL;
 
+static loc_cat_change_cb_t cat_change_cb = NULL;
+
 static void loc_cb_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
+	loc_cat_change_cb_t cb_fun;
+	
 	while (true) {
 		ipc_call_t call;
@@ -66,19 +69,21 @@
 		}
 		
+		int retval;
+		
 		switch (IPC_GET_IMETHOD(call)) {
 		case LOC_EVENT_CAT_CHANGE:
 			fibril_mutex_lock(&loc_callback_mutex);
-			loc_cat_change_cb_t cb_fun = cat_change_cb;
+			cb_fun = cat_change_cb;
+			if (cb_fun != NULL) {
+				(*cb_fun)();
+			}
 			fibril_mutex_unlock(&loc_callback_mutex);
-			
-			async_answer_0(callid, EOK);
-			
-			if (cb_fun != NULL)
-				(*cb_fun)();
-			
+			retval = 0;
 			break;
 		default:
-			async_answer_0(callid, ENOTSUP);
+			retval = ENOTSUP;
 		}
+		
+		async_answer_0(callid, retval);
 	}
 }
@@ -96,34 +101,36 @@
 }
 
-/** Create callback
- *
- * Must be called with loc_callback_mutex locked.
- *
- * @return EOK on success.
- *
- */
 static int loc_callback_create(void)
 {
+	async_exch_t *exch;
+	sysarg_t retval;
+	int rc = EOK;
+
+	fibril_mutex_lock(&loc_callback_mutex);
+	
 	if (!loc_callback_created) {
-		async_exch_t *exch =
-		    loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
 		
 		ipc_call_t answer;
 		aid_t req = async_send_0(exch, LOC_CALLBACK_CREATE, &answer);
-		int rc = async_connect_to_me(exch, 0, 0, 0, loc_cb_conn, NULL);
+		async_connect_to_me(exch, 0, 0, 0, loc_cb_conn, NULL);
 		loc_exchange_end(exch);
 		
+		async_wait_for(req, &retval);
 		if (rc != EOK)
-			return rc;
-		
-		sysarg_t retval;
-		async_wait_for(req, &retval);
-		if (retval != EOK)
-			return retval;
+			goto done;
+		
+		if (retval != EOK) {
+			rc = retval;
+			goto done;
+		}
 		
 		loc_callback_created = true;
 	}
 	
-	return EOK;
+	rc = EOK;
+done:
+	fibril_mutex_unlock(&loc_callback_mutex);
+	return rc;
 }
 
@@ -788,18 +795,22 @@
     sysarg_t **data, size_t *count)
 {
+	service_id_t *ids;
+	size_t act_size;
+	size_t alloc_size;
+	int rc;
+
 	*data = NULL;
-	*count = 0;
-	
-	size_t act_size = 0;
-	int rc = loc_category_get_ids_once(method, arg1, NULL, 0,
+	act_size = 0;	/* silence warning */
+
+	rc = loc_category_get_ids_once(method, arg1, NULL, 0,
 	    &act_size);
 	if (rc != EOK)
 		return rc;
-	
-	size_t alloc_size = act_size;
-	service_id_t *ids = malloc(alloc_size);
+
+	alloc_size = act_size;
+	ids = malloc(alloc_size);
 	if (ids == NULL)
 		return ENOMEM;
-	
+
 	while (true) {
 		rc = loc_category_get_ids_once(method, arg1, ids, alloc_size,
@@ -807,14 +818,16 @@
 		if (rc != EOK)
 			return rc;
-		
+
 		if (act_size <= alloc_size)
 			break;
-		
-		alloc_size = act_size;
-		ids = realloc(ids, alloc_size);
+
+		alloc_size *= 2;
+		free(ids);
+
+		ids = malloc(alloc_size);
 		if (ids == NULL)
 			return ENOMEM;
 	}
-	
+
 	*count = act_size / sizeof(category_id_t);
 	*data = ids;
@@ -854,13 +867,8 @@
 int loc_register_cat_change_cb(loc_cat_change_cb_t cb_fun)
 {
-	fibril_mutex_lock(&loc_callback_mutex);
-	if (loc_callback_create() != EOK) {
-		fibril_mutex_unlock(&loc_callback_mutex);
+	if (loc_callback_create() != EOK)
 		return EIO;
-	}
-	
+
 	cat_change_cb = cb_fun;
-	fibril_mutex_unlock(&loc_callback_mutex);
-	
 	return EOK;
 }
